--------------------------------------------------------------------------------
-- Carnage Contest AI (Artificial Intelligence) Script
-- ghost-AI (it's great when uses ghost rocket, but bazooka is acceptable too)
-- Script by DC, February 2010, www.UnrealSoftware.de
-- edited by farnsworth, March 2010
--------------------------------------------------------------------------------

ai={}
-- how to shoot: by upper or lower trajectory
-- upper is effective in surface (big chance to avoid terrain if bazooka is primary weapon)
-- looks really cool (like boomerang)
-- bad in cave (hits the ceiling)
-- sometimes misses because angle can't be ajusted precizely)
-- lower is more straightforward
-- now it's set to alternate trajectories
ai.C=1
-- the list of non-dead enemies
players={}

-- Initialization Function (called once at each start of AI turn)
function ai_init()
	ai.movetimer=1
	ai.power=100
	players=playertable(3,0)
	print("Gravity is:")
	print(getgravity())
	print("Wind is:")
	print(getwind())
-- coordinates translation for wind compensation
-- wind is the same as gravity in cc physics, so we choose coordinates so that
-- acceleration vector (gravity + wind) goes by y axis. 
	ai.phi=math.atan2(getwind(),getgravity())
	print("rotate coordinates by:")
	print(math.deg(ai.phi))
-- if wind is zero, phi=0, if wind blows right and equals gravity, phi=pi/4 etc.		
	ai.accel=math.sqrt(getgravity()^2+getwind()^2)
	print("Eq. gravity is:")
	print(ai.accel)
-- value of total acceleration

	print("Evaluation of targets")
	print("Number of enemies:")
	print(table.maxn(players))

	for i=1,table.maxn(players),1 do
		print("Player number")
		print(i)
		print("His relative coordinates:")
		ai.targetx=getplayerx(players[i])-getplayerx(0)
		print(ai.targetx)
		ai.targety=getplayery(players[i])-getplayery(0)
		print(ai.targety)
-- translate coordinates
		ai.targetxtr=ai.targetx*math.cos(ai.phi)-ai.targety*math.sin(ai.phi)
		ai.targetytr=ai.targety*math.cos(ai.phi)+ai.targetx*math.sin(ai.phi)
		print("Translated coordinates are:")
		print(ai.targetxtr)
		print(ai.targetytr)
		ai.D=1-ai.accel/100*(ai.accel*(ai.targetxtr)^2/100-2*(ai.targetytr))
		if ai.D>0 then
			print("Of 2 different trajectories")
			ai.C=-ai.C
			if ai.C>0 then
				ai.aim=math.pi/2-math.atan(100/ai.accel/math.abs(ai.targetxtr)*(1+math.sqrt(ai.D)))
				print("Upper one is chosen")
			else
				ai.aim=math.pi/2-math.atan(100/ai.accel/math.abs(ai.targetxtr)*(1-math.sqrt(ai.D)))
				print("Lower one is chosen")
			end				
			if ai.targetxtr<0 then
				ai.aim=-ai.aim
			end
-- translate them back by substracting phi
			ai.aim=mat_round(math.deg(ai.aim-ai.phi))
			break
		else
			print("can't hit the enemy: not enough power")
		end
	end
	if ai.aim>180 then
		ai.aim=ai.aim-360
	elseif ai.aim<-180 then
		ai.aim=ai.aim+360
	end
	if ai.aim<0 then
		ai.dir=0
	else
		ai.dir=1
	end
	print("Set aim to:")
	print(ai.aim)
end

-- Movement Function (called each frame, pre attack)
function ai_move()
	if ai.movetimer>0 then
		if ai.dir==0 then
			ai_left()
		else
			ai_right()
		end
		ai.movetimer=ai.movetimer-1
	elseif ai.aim~=getplayerrotation(0) then
		if (ai.aim-getplayerrotation(0))*(2*ai.dir-1)>0 then
			ai_down()
		else
			ai_up()
		end
	elseif ai.power>0 then
		ai_attack()
		ai.power=ai.power-1
	end
end

-- Backing Function (called each frame, post attack)
function ai_back()
-- let him just stand!
	if ai.dir==0 then
--		ai_right()
	else
--		ai_left()
	end
end
function mat_round(x)
	if (x-math.floor(x))>0.5 then
		return math.ceil(x)
	else
		return math.floor(x)
	end
end
--------------------------------------------------------------------------------
-- AI Helper Functions
-- Attention: These functions are also used by orig. AI weapon Lua scripts
-- !!! CHECK ALL DEPENDENCIES WHEN CHANGING !!!
--------------------------------------------------------------------------------